#!/bin/bash

iptables=`which iptables`

[ "$1" == "" ] && exit 

if [ "$1" == "create" ]; then
   # standard rules
   $iptables -t mangle -D POSTROUTING -o $1 -j RtSec 1>/dev/null 2>/dev/null
   $iptables -t mangle -X RtSec 1>/dev/null 2>/dev/null
   $iptables -t mangle -F RtSec 1>/dev/null 2>/dev/null
   $iptables -t mangle -N RtSec
   $iptables -t mangle -A RtSec -s 127.0.0.1 -j RETURN

   # search the ethernet interfaces
   for iffw in `ip link ls | grep -v "link" | cut -d":" -f2`;
   do
    
     # search the IP addr of witch interface
     [ "$iffw" != "lo" ] && \
       for netsec in `ip route ls dev $iffw scope link | grep "/" | awk '{print $1}'`;
       do
          $iptables -t mangle -A RtSec -s $netsec -j RETURN
       done

   done
   $iptables -t mangle -A RtSec -j DROP
   
   $iptables -N fwaccept 
   $iptables -A fwaccept -p icmp -m limit --limit 1/s --limit-burst 2 -j ACCEPT
   $iptables -A fwaccept -p tcp --syn -m limit --limit 1/s -m state --state NEW -j ACCEPT
   $iptables -A fwaccept -p tcp --syn -m state --state NEW -j DROP
   $iptables -A fwaccept -j ACCEPT
   
else
   $iptables -t mangle -A POSTROUTING -o $1 -j RtSec
fi

