#!/bin/bash
###################################################################################
#
#  fwadsl 2005 v3 
#
#  USED FOR CONFIGURATIONS FIREWALL PROFILES, HOW:
#  - NEW CHAINS
#  - HOSTS PROFILE (KIND OF SERVICES)
#  - RULES FOR REDIR CONNECTIONS
#
#  THIS SCRIPT APPLY TO ACCESS PROFILE FOR LOCAL USERS, EMAIL CONTROL AND
#  DROP SPECIAL PORTS AND NETWORKS (DEFAULT BLOCK FOR MSN, ICQ AND IRC)
#
#  Por: Humberto L Juca
#    
###################################################################################

iptables=$(which iptables)
curdir=$(dirname $0)

# MAKING PROFILE RULES
profi()
{ chain=$(echo $line | awk '{print $2}')
  proto=$(echo $line | awk '{print $3}')
  port=$(echo $line | awk '{print $4}')
  target=$(echo $line | awk '{print $5}')
  $iptables -N $chain 2>/dev/null 1>/dev/null
  if [ "$chain" == "admin" ]; then
     $iptables -A $chain -m multiport -p $proto --dport $port --syn -j LOG --log-level info --log-prefix "[ Admin access ]: " 2>/dev/null
  fi
  case "$proto" in
     tcp) 
       [ "$target" == "ACCEPT" ] && port="$port --syn" 
       $iptables -A $chain -m multiport -p $proto --dport $port -j $target 2> /dev/null
     ;;
     -) $iptables -A $chain -j $port ;;
     *)  
       $iptables -A $chain -m multiport -p $proto --dport $port -j $target 2> /dev/null
  esac 
}

# MAKING EMAIL REDIRECTION RULES
redir()
{ chain=$(echo $line | awk '{print $2}')
  type=$(echo $line | awk '{print $3}')
  ifredir=$(echo $line | awk '{print $4}')
  ipadd=$(echo $line | awk '{print $5}')
  [ "$type" == "new" ] && \
     $iptables -t nat -N $chain || \
     $iptables -t nat -A $chain -i $ifredir -s $ipadd -j RETURN
}

# MAKING DROP RULES
drop()
{ type=$(echo $line | awk '{print $2}')
  if [ "$type" == "port" ]; then
    proto=$(echo $line | awk '{print $3}')
    port=$(echo $line | awk '{print $4}')
    [ "$defifrt" == "" ] &&  ifrt=$(echo $line | awk '{print $5}')
    $iptables -t mangle -A POSTROUTING -o $ifrt -p $proto --dport $port -j DROP    
  else
    svraddr=$(echo $line | awk '{print $3}')
    [ "$defifrt" == "" ] &&  ifrt=$(echo $line | awk '{print $4}')
    if [ "$type" == "route" ]; then
       ip route add prohibit $svraddr 2>/dev/null
    else
       $iptables -t mangle -A POSTROUTING -o $ifrt -d $svraddr -j DROP
    fi
  fi
}

# READING FILE PROFILE.DEF FOR "PROFILE" DEFINITIONS
while read line;
do
  flag=$(echo $line | grep '[#;]' | tr -d ' ' | wc -l)
  space=$(echo $line | tr -d ' ')
  if [ "$flag" -lt 1 ] && [ "$space"au != au ] ; then
     flprof=$(echo $line | cut -f1 -d" ")
     case "$flprof" in
	profile) profi ;;
        redir) redir ;;
        drop) drop ;;
        defif) defifrt=$(echo $line | awk '{print $2}') 
	       ifrt=$defifrt ;;
     esac 
  fi
done < $curdir/profile.def

