#!/bin/bash

HOMEDEF_SV=`dirname $0`
iptables=`which iptables`

servconf()
{
  $iptables -A FORWARD -o $if_loc -d $ipsvr -p icmp -m limit --limit 1/s --limit-burst 2 -j ACCEPT
  
  if [ $nrp -eq 0 ]; then
     $iptables -A FORWARD -o $if_loc -d $ipsvr -p $proto --dport $ports -j $target
     $iptables -A FORWARD -i $if_loc -s $ipsvr -p $proto --sport $ports -j $target
  else
     $iptables -A FORWARD -o $if_loc -d $ipsvr -m multiport -p $proto --dport $ports -j $target
     $iptables -A FORWARD -i $if_loc -s $ipsvr -m multiport -p $proto --sport $ports -j $target
  fi
}

servlog()
{ 
  lim=`echo $line | awk '{print $2}'`
  limbrt=`echo $line | awk '{print $3}'`
  msg=`echo $line | cut -d" " -f4-`
  if [ $nrp -eq 0 ]; then
     $iptables -t nat -A PREROUTING -d $ipsvr -p $proto --dport $ports \
       -m limit --limit $lim --limit-burst $limbrt -j LOG --log-level info --log-prefix $msg" "
  else
     $iptables -t nat -A PREROUTING -d $ipsvr -m multiport -p $proto --dport $ports \
       -m limit --limit $lim --limit-burst $limbrt -j LOG --log-level info --log-prefix $msg" "
  fi
}

servdrop()
{
  dtype=`echo $line | awk '{print $2}'`
  inif=`echo $line | awk '{print $3}'`
  dip=`echo $line | awk '{print $4}'`
  if [ "$dtype" == "srv" ]; then
    [ $nrp -eq 0 ] && \
      $iptables -t mangle -A PREROUTING -i $inif -s $dip -d $ipsvr -p $proto --dport $ports -j DROP || \
      $iptables -t mangle -A PREROUTING -i $inif -s $dip -d $ipsvr -m multiport -p $proto --dport $ports -j DROP
  fi
  [ "$dtype" == "all" ] && \
     $iptables -t mangle -A PREROUTING -i $inif -s $dip -j DROP
}

while read line
do
  flag=`echo $line | grep '[#;]' | tr -d ' ' | wc -l`
  space=`echo $line | tr -d ' '`
  if [ "$flag" -lt 1 ] && [ "$space"au != au ] ; then
    linaux=`echo $line | awk '{print $1}'`
    if [ "$linaux" == "service" ]; then
       if_loc=`echo $line | awk '{print $3}'`
       ipsvr=`echo $line | awk '{print $4}'`
       proto=`echo $line | awk '{print $5}'`
       ports=`echo $line | awk '{print $6}'`
       target=`echo $line | awk '{print $7}'`
       nrp=`echo $ports | grep "," | wc -l | awk '{print $1}'` 
       servconf
    fi
    [ "$linaux" == "log" ] && servlog
    [ "$linaux" == "drop" ] && servdrop
  fi
done < $HOMEDEF_SV/services.def 
